% CoMa2 - SS11
% Aufg.9.3
function Y = alkabbau_exEul(D,tau,T,i0,b0)
% (was genau berechnet wird, ist nachzulesen...)
% expl.Euler fr ein spezielles nichtlineares System von Dfgln.
% Inputs: Parameter D(Alkoholdosis), Schrittweite tau, Endzeitpunkt T, 
% Anfangswerte i0,b0 (Alkoholkonzentration im Dnndarm bzw. Blut)

% Output: Matrix Y, wobei Y(:,k) = [I(k);B(k)]

% Parameter:
% maximale Abbaurate im Magen (in 1/h)
ke_max = 10.21;
% Proportionalittskonstante fr Dosisabhngigkeit der Abbaurate im Magen
% (in 1/g^2)
a = 0.001671;
% Abbaurate im Magen (D in g)
ke = ke_max / (1+a*D^2);
% absorbierter Anteil
F = 0.785;
% Blutvolumen (in l)
V = 44.1;
% Abbaurate im Darm (in 1/h)
ka = 25.11;
% maximale Abbaugeschwindigkeit im Blut (in g/(l*h))
vmax = 0.202;
% Michaelis-Menten-Konstante (in g/l)
Km = 0.0818;

% expl.Euler:
N = T/tau;
Y = zeros(2,N+1);
Y(:,1) = [i0;b0];
for k=1:N
    Y(1,k+1) = Y(1,k) + tau*(-ka*Y(1,k) + ke*(F*D/V)*exp(-ke*k*tau));
    Y(2,k+1) = Y(2,k) + tau*(-vmax*Y(2,k)/(Km+Y(2,k)) + ka*Y(1,k));
end